
#include "LUAEXIT.H"

#include <stdlib.h>

typedef struct s_Struct_Lua_Exit_Parm {
    short       (*pGetLuaNumericValue) (double **value);
    short       (*pGetLuaStringValue) (UChar **value);
    short       (*pPutLuaNumericValue) (double value);
    short       (*pPutLuaStringValue) (UChar *pValue);
    UChar       *pSrcDBAliasName;
    UChar       *pSrcCreatorID;
    UChar       *pSrcTableName;
    UChar       *pDstDBAliasName;
    UChar       *pDstCreatorID;
    UChar       *pDstTableName;
    long         RowNumCur;
    long         MaxRows;
    char         RDBCD_DBMSType;
} PST_STRUCT_LUA_EXIT_PARM;

#ifdef STRING_EXIT
__declspec(dllexport)
short PSTLuaUserExit(PST_STRUCT_LUA_EXIT_PARM *pInputParms) 
{
     UChar  *pInput;
     UChar  *pOutput;
     short   rc = 0;
     U_STRING_DECL(O, "O", 1);
     U_STRING_INIT(O, "O", 1);

     rc = (*pInputParms->pGetLuaStringValue)(&pInput);
     if (rc == 0) {
         pOutput = malloc(48*sizeof(UChar));
         u_strcpy(pOutput, O);
         u_strcat(pOutput, pInput);
         (*pInputParms->pPutLuaStringValue)(pOutput);
     } else {
        // TODO:
        return 1;
     }
     return 0;
}
#else
__declspec(dllexport)
short PSTLuaUserExit(PST_STRUCT_LUA_EXIT_PARM *pInputParms) 
{
     double  *pInput;
     double  Output;
     short   rc = 0;
     U_STRING_DECL(O, "O", 1);
     U_STRING_INIT(O, "O", 1);

     rc = (*pInputParms->pGetLuaNumericValue)(&pInput);
     if (rc == 0) {
         Output = *pInput + 1.0;
         (*pInputParms->pPutLuaNumericValue)(Output);
     } else {
        // TODO:
        return 1;
     }
     return 0;
}
#endif